import { SwfServiceCatalogFunction, SwfServiceCatalogService } from "@kie-tools/serverless-workflow-service-catalog/dist/api";
import { TextDocument } from "vscode-json-languageservice";
import { CompletionItem, Position, Range } from "vscode-languageserver-types";
import { SwfLanguageServiceConfig } from "./SwfLanguageService";
import { CodeCompletionStrategy, SwfLsNode } from "./types";
declare type SwfCompletionItemServiceCatalogFunction = SwfServiceCatalogFunction & {
    operation: string;
};
export declare type SwfCompletionItemServiceCatalogService = Omit<SwfServiceCatalogService, "functions"> & {
    functions: SwfCompletionItemServiceCatalogFunction[];
};
export declare type SwfLanguageServiceCodeCompletionFunctionsArgs = {
    document: TextDocument;
    overwriteRange: Range;
    currentNode: SwfLsNode;
    currentNodeRange: Range;
    rootNode: SwfLsNode;
    codeCompletionStrategy: CodeCompletionStrategy;
    swfCompletionItemServiceCatalogServices: SwfCompletionItemServiceCatalogService[];
    langServiceConfig: SwfLanguageServiceConfig;
};
export declare const SwfLanguageServiceCodeCompletion: {
    getEmptyFileCodeCompletions(args: {
        cursorPosition: Position;
        codeCompletionStrategy: CodeCompletionStrategy;
    }): CompletionItem[];
    getFunctionCompletions: (args: SwfLanguageServiceCodeCompletionFunctionsArgs) => Promise<CompletionItem[]>;
    getFunctionOperationCompletions: (args: SwfLanguageServiceCodeCompletionFunctionsArgs) => Promise<CompletionItem[]>;
    getFunctionRefCompletions: (args: SwfLanguageServiceCodeCompletionFunctionsArgs) => Promise<CompletionItem[]>;
    getFunctionRefRefnameCompletions: (args: SwfLanguageServiceCodeCompletionFunctionsArgs) => Promise<CompletionItem[]>;
    getFunctionRefArgumentsCompletions: (args: SwfLanguageServiceCodeCompletionFunctionsArgs) => Promise<CompletionItem[]>;
};
export {};
//# sourceMappingURL=SwfLanguageServiceCodeCompletion.d.ts.map